/* int^WIntSetiwb_j*/

#ifndef ___IntSet
#define ___IntSet

/*--- RgɁ̂֐K7-1Œǉꂽ֐ł ---*/

/*--- int^̏W\ ---*/
typedef struct {
	int max;	/* W̗e */
	int num;	/* W̗vf */
	int *set;	/* W{̂̔zi̐擪vfւ̃|C^j*/
} IntSet;

/*--- W̏ ---*/
int Initialize(IntSet *s, int max);

/*--- WsnĂ邩 ---*/
int IsMember(const IntSet *s, int n);

/*--- Ws͖tivfǉłȂԁj ---*/
int IsFull(const IntSet *s);

/*--- Wsnǉ ---*/
void Add(IntSet *s, int n);

/*--- Wsn폜 ---*/
void Remove(IntSet *s, int n);

/*--- Wsi[łő̗vf ---*/
int Capacity(const IntSet *s);

/*--- Ws̗vf ---*/
int Size(const IntSet *s);

/*--- Ws2s1ɑ ---*/
void Assign(IntSet *s1, const IntSet *s2);

/*--- Ws1s2͓ ---*/
int Equal(const IntSet *s1, const IntSet *s2);

/*--- Ws2s3̘aWs1ɑ ---*/
IntSet *Union(IntSet *s1, const IntSet *s2, const IntSet *s3);

/*--- Ws2s3̐ϏWs1ɑ ---*/
IntSet *Intersection(IntSet *s1, const IntSet *s2, const IntSet *s3);

/*--- Ws2s3Ws1ɑ ---*/
IntSet *Difference(IntSet *s1, const IntSet *s2, const IntSet *s3);

/*--- Ws2s3̑Ώۍs1ɑ ---*/
IntSet *SymmetricDifference(IntSet *s1, const IntSet *s2, const IntSet *s3);

/*--- Ws1ɑ΂ďWs2̑Svfǉ ---*/
IntSet *ToUnion(IntSet *s1, const IntSet *s2);

/*--- Ws1Ws2Ɋ܂܂ȂSvf폜 ---*/
IntSet *ToIntersection(IntSet *s1, const IntSet *s2);

/*--- Ws1Ws2Ɋ܂܂Svf폜 ---*/
IntSet *ToDifference(IntSet *s1, const IntSet *s2);

/*--- Ws1s2̕W ---*/
int IsSubset(const IntSet *s1, const IntSet *s2);

/*--- Ws1s2̐^W ---*/
int IsProperSubset(const IntSet *s1, const IntSet *s2);

/*--- Ws̑Svf\ ---*/
void Print(const IntSet *s);

/*--- Ws̑Svf\istj---*/
void PrintLn(const IntSet *s);

/*--- Ws̑Svf폜 ---*/
void Clear(IntSet *s);

/*--- W̌n ---*/
void Terminate(IntSet *s);

#endif
