/* zEdAXgiwb_j*/

/* ֐PurgeƊ֐RetrieveList9-7ɒǉ */

#ifndef ___CircDblLinkedList
#define ___CircDblLinkedList

#include "Member.h"

/*--- m[h ---*/
typedef struct __node {
	Member        data;			/* f[^ */
	struct __node *prev;		/* sm[hւ̃|C^ */
	struct __node *next;		/* 㑱m[hւ̃|C^ */
} Dnode;

/*--- zEdAXg ---*/
typedef struct {
	Dnode *head;				/* 擪_~[m[hւ̃|C^ */
	Dnode *crnt;				/* ڃm[hւ̃|C^ */
} Dlist;

/*--- Xg ---*/
void Initialize(Dlist *list);

/*--- ڃm[h̃f[^\ ---*/
void PrintCurrent(const Dlist *list);

/*--- ڃm[h̃f[^\istj---*/
void PrintLnCurrent(const Dlist *list);

/*--- ֐compareɂxƈvƔ肳m[hT ---*/
Dnode *Search(Dlist *list, const Member *x,
			  int compare(const Member *x, const Member *y));

/*--- 擪n̃m[hւ̃|C^擾 ---*/
Dnode *Retrieve(Dlist *list, int n);

/*--- Sm[h̃f[^Xgɕ\ ---*/
void Print(const Dlist *list);

/*--- Sm[h̃f[^Xg̋tɕ\ ---*/
void PrintRevese(const Dlist *list);

/*--- ڃm[hɐi߂ ---*/
int Next(Dlist *list);

/*--- ڃm[hOɖ߂ ---*/
int Prev(Dlist *list);

/*--- pwm[h̒Ƀm[h} ---*/
void InsertAfter(Dlist *list, Dnode *p, const Member *x);

/*--- 擪Ƀm[h} ---*/
void InsertFront(Dlist *list, const Member *x);

/*--- Ƀm[h} ---*/
void InsertRear(Dlist *list, const Member *x);

/*--- pwm[h폜 ---*/
void Remove(Dlist *list, Dnode *p);

/*--- 擪m[h폜 ---*/
void RemoveFront(Dlist *list);

/*--- m[h폜 ---*/
void RemoveRear(Dlist *list);

/*--- ڃm[h폜 ---*/
void RemoveCurrent(Dlist *list);

/*--- Sm[h폜 ---*/
void Clear(Dlist *list);

/*--- r֐ɂēƂ݂Ȃm[h폜 ---*/
void Purge(Dlist *list, int compare(const Member *x, const Member *y));

/*--- zEdAXgn ---*/
void Terminate(Dlist *list);

#endif
